#!/usr/bin/env groovy

println("analysis");

if (this.args.size() < 3){
  println("usage: analysis experiment-name workload-file-name csv-file-name");
  return;
}
for (a in this.args) {
  println("Argument: " + a);
}

experimentName=args[0];
wkldFileName=args[1];
csvFileName=args[2];
processReqRegExp=/processRequest: senp\{version=1 method=\"(\w+)\"/;
clientLogFileNameRegExp=/D.+/;
csvFile = new File(csvFileName);
csvFile.write('"Server/Packet","DV","UDV","PUB","SUB","DRP","CNF","False Pos","Total"\n');
// closure filling out the statistics from server logs
countServerIncomingPackets={
    logFile = new File(it);
    int dv = 0;
    int udv = 0;
    int pub = 0;
    int sub = 0;
    int drp = 0;
    int cfg = 0;
    int false_pos = 0;
    for (line in logFile.readLines()){
                     matcher = (line =~ processReqRegExp);
                     if (matcher){
                         //println(line);                                               
                         //println(matcher[0]);                        
                        switch (matcher[0][1]) {
                            case "DV":
                                dv++;
                                break;
                            case "UDV":
                                udv++;
                                break;
                            case "PUB":
                                pub++;
                                break;
                            case "SUB":
                                sub++;
                                break;
                            case "DRP":
                                drp++;
                                break;
                            case "CNF":
                                cfg++
                        }
                     }  else {
                         matcher = (line =~ /DV\/DRP false positive/);
                         if (matcher){
                             false_pos++;
                         }
                     }
     }
     
     csvFile.append("${it}, ${dv}, ${udv}, ${pub}, ${sub}, ${drp}, ${cfg}, ${false_pos}, ${dv + udv + pub + sub + drp + cfg}\n");
};

invokeClientAnalysis = {
    println(it);
    matcher = (it =~ clientLogFileNameRegExp);
    //println(matcher);    
    if(matcher){        
        actor = matcher[0][1];
        //println(actor);
        runAnalysis="groovy compareExpectedWLog.groovy ${wkldFileName} C${actor} ${it}";
        //println(runAnalysis);
        csvFile.append(it+",");
        runAnalysis.execute().in.eachLine({println(it); csvFile.append("${it.substring(it.indexOf(":")+1)},")});
        csvFile.append("\n");
    }
}

//call shell command, finding server logs
findServerLogs = ["sh", "-c", "ls ${experimentName}_S*.log"];
//for each server log invoke the closure
findServerLogs.execute().in.eachLine(countServerIncomingPackets);
csvFile.append('\n');
csvFile.append('"Actor/Action","Sub","Pub","Rec","Expected","FalseNeg","FalsePos"\n');
findClientLogs = ["sh", "-c", "ls weevil-parallel/actorstartoutput/1/D*\\.out"];
findClientLogs.execute().in.eachLine(invokeClientAnalysis);


