#!/usr/bin/env groovy
package siena;
import siena.*;

println("extractFPFNplotData");

if (this.args.size() < 4){
  println("usage: extractClientFPFNplotData mergedLogFileName fn-data-series fp-data-series window-millisec");
  return;
}
for (a in this.args) {
  println("Argument: " + a);
}

logFile = new File(args[0]);
fnFile = new File(args[1]);
fnFile.write("");
fpFile = new File(args[2]);
fpFile.write("");
int period = Integer.parseInt(args[3]); // size of the moving average window in milliseconds
String[] lines = logFile.readLines();
Map filters = new HashMap();

//assert "301 D2 subscribing for 0: { influenced >47}" =~ /\d+ (\w+) (\w+).+ \d: (\{.+\})/;
//11230 S6 DV/DRP false positive on senp{version=1 method="PUB" ttl=27 id="S3" to="S6" BSet="AEgAAgBAEECAAgAMAQAIAAOAAEAAAAgAAAgUAAAAAAA=" recList={S6 }}
//11230 S6 [4] processRequest: senp{version=1 method="DRP" ttl=28 id="S3" to="S6" BSet="AEgAAgBAEECAAgAMAQAIAAOAAEAAAAgAAAgUAAAAAAA=" recList={S6 }}
//assert '11230 S6 [4] processRequest: senp{version=1 method="DRP" ttl=28 id="S3" to="S6" BSet="AEgAAgBAEECAAgAMAQAIAAOAAEAAAAgAAAgUAAAAAAA=" recList={S6 }}' =~ '\\d+.+processRequest.+DRP.+recList\\=\\{([\\w ]+)\\}';

int iteration = 1;
int falseNeg = 0;
int falsePos = 0;
int msgs = 0;
int pubs = 0;
int received = 0;
int fpUnneededPacket = 0;
int drp = 0;

//println(cmd);
pattern = /(\d+) (\w+) (\w+) .*\d: (\{.+\}){0,1}/;
for(i in 0..lines.size()-1){
    matcher = (lines[i] =~ pattern);
    //println(lines[i]);      
    //301 D2 subscribing for 0: { influenced >47}
    //1241 D6 publishing 0: { Corinthianizes=91 msgId="C6m0" sanctum="Oberlin" tedious=8}
    //18078 D1 getting 1: { absolution=65 hedge=97 msgId="C3m1" sanctum=54}
    //20034 D4 unsubscribing 0: SUB(0, `"i identities < 63"')
    //24550 S4 DV/DRP false positive on senp{    
    if (matcher) {
        //println(matcher[0][0]);        
        // check if moving average period is over, print results and set counters to 0
        int time = Integer.parseInt(matcher[0][1]);        
        while( time > (iteration * period)){
            if (falseNeg != 0){
                fnFile.append(iteration * period + "\t" + falseNeg / (falseNeg + received) + "\t" + falseNeg + "\t" + received + "\n");
            } else {
                fnFile.append(iteration * period + "\t" + 0 + "\t" + falseNeg + "\t" + received + "\n");
            }
            if (drp != 0){
                fpFile.append(iteration * period  + "\t" + fpUnneededPacket / drp + "\t" + fpUnneededPacket + "\t" + drp + "\n");
            } else {
                fpFile.append(iteration * period  + "\t" + 0 + "\t" + fpUnneededPacket + "\t" + drp + "\n");
            }
            falseNeg = 0;
            falsePos = 0;
            msgs = 0;
            pubs = 0;
            fpUnneededPacket = 0;
            drp = 0;
            received = 0;
            iteration++;
        }
        switch (matcher[0][3]) {
            case "subscribing" :
                SENPBuffer pckt = new SENPBuffer(matcher[0][4].getBytes());
                Filter f = pckt.decodeFilter();
                List nodeFilters = filters.get(matcher[0][2]);
                if (nodeFilters == null){
                    nodeFilters = new ArrayList();
                }
                nodeFilters.add(f);
                filters.put(matcher[0][2], nodeFilters);
                break;   
            case "publishing" :
                pubs++;
                //println("msg line: " + matcher[0][0]);                
                SENPBuffer pckt = new SENPBuffer(matcher[0][4].getBytes());
                Notification n = pckt.decodeNotification();
                String msgId = n.getAttribute("msgId");
                //println("msgId: ${msgId}");
                // look for matching subscriptions
                for(node in filters.keySet()){
                    //println(node);
                    int k = 0;
                    boolean found = false;
                    while(k < filters.get(node).size() && !found){
                        filter = filters.get(node)[k];
                        //println(filter);
                        if (Covering.apply(filter, n)){
                            msgs++;
                            //println("${matcher[0][1]} ${node} filter ${filter} covers ${n}");
                            // here we search the rest of the log to find if msg was delivered
                            String getRegExp = "\\d+ " +  node + ' getting.*' + msgId ;
                            int j = (i > 100) ? i - 100 : 0 ; 
                            // changed: we look 1000 lines in the past and forward in the rest of the log as we cannot 
                            // really trust log timings and delivery timings                                                      
                            while(j < lines.size() && j < i + 100 && !found){                                                                
                                match = (lines[j] =~ getRegExp);
                                if (match){
                                   found = true;
                                   //println("Match: ${lines[j]}");                                    
                               }
                               j++;
                           }
                           if (!found) {
                             falseNeg++;
                             println("False Negative: ${time} ${n} was not delivered to ${node}");
                           }                           
                        }
                     k++;
                    }
                }   
                // look for false positives
                int j = i ; 
                // changed: we only look ahead assuming we've restored causality order at least for DRP packets                
                String fpRegExp = "\\d+ (\\w+) " + '.*false positive.*' + msgId ;
                List fpNodeIds = [];
                String[] cmd = ["sh", "-c","grep -E 'false positive.*${msgId}' ${args[0]}"];
                cmd.execute().in.eachLine(){                                    
                        match = (it =~ fpRegExp);
                         if (match){
                             fpNodeIds.add(match[0][1]);
                             println("False Positive: ${it}"); 
                             falsePos++;
                         }                  
                }                
                if (fpNodeIds.size() > 0) {
                    println("fpNodeIds: ${fpNodeIds} ");
                    // here we count how many uneeded hops were traversed
                    // we measure percentage of fp as no. unneded hops  / total hops traversed by all DRP msg (including to other destinations and for other events)
                     int k = i ; 
                     // changed: we only look ahead assuming we've restored causality order at least for DRP packets                    
                    String drpRegExp = '(\\d+).+processRequest.+DRP.+recList\\=\\{([\\w ]+)\\}.*' + msgId ;
                    while(k < lines.size() && k < i + 100){                      
                            match = (lines[k] =~ drpRegExp);
                             if (match){                                 
                                 //println(match[0]);
                                 // recList={S3 S6 }
                                 nodeIdsMatcher = (match[0][2] =~ /(\w+)/);
                                 if (nodeIdsMatcher){
                                     //println("nodeIdsMatcher: ${nodeIdsMatcher}");
                                     List packetNodes = [];
                                     for(p in 0..nodeIdsMatcher.getCount()-1){
                                         packetNodes.add(nodeIdsMatcher[p][1]);
                                     }
                                     println("packetNodes: ${packetNodes}");
                                     if (packetNodes.findAll({!fpNodeIds.contains(it)}).size() == 0){
                                     // if nodes are only the ones among fpNodeIds we got ourself an unneeded packet
                                     fpUnneededPacket++;
                                     println("fpNodeIds.contains(packetNodes)");
                                     }
                                 }
                                 // we add to drp count if we're getting outside of the current window
                                 // and "consume" (e.g. delete) the line so that it is not added to other windows
                                 // this induces some error as DRP packets are all considered in the same window as 
                                 // their originating PUB
                                 // (at least we prevent FP percentages of more than 100%)
                                 int lineTime = Integer.parseInt(match[0][1]);
                                 if(lineTime > iteration * period || lineTime < (iteration -1) * period) {
                                     drp++;
                                     lines.remove(k);
                                     // prevent line skipping
                                     k--;
                                 }
                             }                             
                      k++;
                    }
                }                
                break;
            case "unsubscribing" :                
                List nodeFilters = filters.get(matcher[0][2]);                
                // note: the simulations we write always have FIFO unsubscription logic
                // FIXME: this can lead to errors whether the actual workload timing breaks this logic                
                nodeFilters.remove(0);                
                // if something goes wrong we should get an exception here
                filters.put(matcher[0][2], nodeFilters);
                break;
            case "getting" :
                received++;
        }
    }
    // counter for DRP packets
    if (lines[i] =~ /processRequest: senp\{version\=1 method\=\"DRP\"/){
        drp++;
    }
}
 if (falseNeg != 0){
    fnFile.append(iteration * period + "\t" + falseNeg / (falseNeg + received) + "\t" + falseNeg + "\t" + received + "\n");
} else {
    fnFile.append(iteration * period + "\t" + 0 + "\t" + falseNeg + "\t" + received + "\n");
}
if (drp != 0){
    fpFile.append(iteration * period  + "\t" + fpUnneededPacket / drp + "\t" + fpUnneededPacket + "\t" + drp + "\n");
} else {
    fpFile.append(iteration * period  + "\t" + 0 + "\t" + fpUnneededPacket + "\t" + drp + "\n");
}
//println(filters);
