// this file is automatically created by WEEVIL, do not modify manually
#include <iostream>
#include <siena/ssim.h>

// WVL: begin WorkloadProcessType source files
#include "gen_message.h"
#include "gen_message.cc"
#include "sienaclient.cc"
// WVL: end WorkloadProcessType source files

int main( int argc, char** argv )
{
	// Initialize processes

	SienaClient C1( "C1" );
	C1.id( "C1" );
	C1.pid( ssim::Sim::create_process( &C1 ) );
	weevil::WeevilGen::add_process( C1.id(), C1.pid() );

	SienaClient C2( "C2" );
	C2.id( "C2" );
	C2.pid( ssim::Sim::create_process( &C2 ) );
	weevil::WeevilGen::add_process( C2.id(), C2.pid() );

	SienaClient C3( "C3" );
	C3.id( "C3" );
	C3.pid( ssim::Sim::create_process( &C3 ) );
	weevil::WeevilGen::add_process( C3.id(), C3.pid() );


	// Set properties
	C1.sub_neighbors( "C2 PUB 3 0.02|C3 SUB 2 0.01|" );
	C1.pub_neighbors( "C2 SUB 3 0.01|" );
	C1.constr_min( 1 );
	C1.constr_max( 1 );
	C1.attr_min( 1 );
	C1.attr_max( 3 );
	C1.attr_dist_f( "attr_names.dist" );
	C1.constr_dist_f( "constr_names.dist" );
	C1.types_dist_f( "types.dist" );
	C1.op_dist_f( "operators.dist" );
	C1.op_string_dist_f( "string_operators.dist" );
	C1.str_dist_f( "str_values.dist" );
	C1.int_dist_f( "int_values.dist" );
	C1.bool_dist_f( "bool_values.dist" );
	C1.num_subs( 50 );
	C1.sub_timeout( 100 );
	C1.unsub_timeout( 200 );
	C1.num_pubs( 0 );
	C1.pub_timeout( 100 );
	C2.sub_neighbors( "C3 SUB 2 0.02|" );
	C2.pub_neighbors( "C3 PUB 2 0.01|" );
	C2.constr_min( 2 );
	C2.constr_max( 4 );
	C2.attr_min( 2 );
	C2.attr_max( 4 );
	C2.attr_dist_f( "attr_names.dist" );
	C2.constr_dist_f( "constr_names.dist" );
	C2.types_dist_f( "types.dist" );
	C2.op_dist_f( "operators.dist" );
	C2.op_string_dist_f( "string_operators.dist" );
	C2.str_dist_f( "str_values.dist" );
	C2.int_dist_f( "int_values.dist" );
	C2.bool_dist_f( "bool_values.dist" );
	C2.num_subs( 0 );
	C2.sub_timeout( 200 );
	C2.unsub_timeout( 300 );
	C2.num_pubs( 40 );
	C2.pub_timeout( 200 );
	C3.sub_neighbors( "C1 PUB 5 0.01|" );
	C3.pub_neighbors( "C1 SUB 5 0.01|" );
	C3.constr_min( 1 );
	C3.constr_max( 2 );
	C3.attr_min( 3 );
	C3.attr_max( 5 );
	C3.attr_dist_f( "attr_names.dist" );
	C3.constr_dist_f( "constr_names.dist" );
	C3.types_dist_f( "types.dist" );
	C3.op_dist_f( "operators.dist" );
	C3.op_string_dist_f( "string_operators.dist" );
	C3.str_dist_f( "str_values.dist" );
	C3.int_dist_f( "int_values.dist" );
	C3.bool_dist_f( "bool_values.dist" );
	C3.num_subs( 0 );
	C3.sub_timeout( 250 );
	C3.unsub_timeout( 400 );
	C3.num_pubs( 20 );
	C3.pub_timeout( 250 );

	// Start killer process (if necessary)
	ssim::Sim::create_process( new weevil::KillerProcess( 10000 ) );

	ssim::Sim::run_simulation();
}
