// -*- C++ -*-
//
//  This file is part of WEEVILGEN.
//
//  Authors: See the file AUTHORS for full details.
//
//  Copyright (C) 2002-2004 University of Colorado
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307,
//  USA, or send email to serl@cs.colorado.edu.
//
// $Id: gen_message.h,v 1.1.1.1 2004/11/02 23:36:43 ywang Exp $
//
#ifndef _gen_message_h
#define _gen_message_h

#include <sys/time.h>
#include <math.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <sstream>
#include <set>

#include "wset.h"

using namespace std;

/**
 * Generator for Subscription and Notification message
 */
class Message_Generator{
  /*attributes for the content of message*/
  unsigned int		m_constr_min;
  unsigned int		m_constr_max;
  unsigned int		m_attr_min;
  unsigned int		m_attr_max;
  char*				m_attr_dist_f;
  char*				m_constr_dist_f;
  char*				m_types_dist_f;
  char*				m_op_dist_f;
  char*				m_op_string_dist_f;
  char*				m_str_dist_f;
  char*				m_int_dist_f;
  char*				m_bool_dist_f;

  wset<string>		attr_dist;
  wset<string>		constr_dist;
  wset<string>		op_dist;
  wset<string>		op_string_dist;
  wset<char>		types_dist;
  wset<string>		str_dist;
  wset<int>			int_dist;
  wset<bool>		bool_dist;

 public:
  void constr_min( unsigned int cmin )
  { m_constr_min = cmin; }

  void constr_max( unsigned int cmax )
  { m_constr_max = cmax; }

  void attr_min( unsigned int amin )
  { m_attr_min = amin; }

  void attr_max( unsigned int amax )
  { m_attr_max = amax; }

  void attr_dist_f( char* adist )
  { m_attr_dist_f = adist; }

  void constr_dist_f( char* cdist )
  { m_constr_dist_f = cdist; }

  void types_dist_f( char* tdist )
  { m_types_dist_f = tdist; }

  void op_dist_f( char* odist )
  { m_op_dist_f = odist; }

  void op_string_dist_f( char* osdist )
  { m_op_string_dist_f = osdist; }

  void str_dist_f( char*	sdist )
  { m_str_dist_f = sdist; }

  void int_dist_f( char*	idist )
  { m_int_dist_f = idist; }

  void bool_dist_f( char* bdist )
  { m_bool_dist_f = bdist; }

  string generator(string eventtype);
  int readdist();
  /**generate a random number of uniform distribution from 0 to max-1*/
  int rand_normal(int max);
  /**generate a random number of uniform distribution from min to max-1*/
  int rand_normal_range(int min, int max);
};



#endif
