# -*- sh -*-
#
#  This file is part of WEEVIL.
#
#  Authors: See the file AUTHORS for full details.
#
#  Copyright (C) 2002-2006 University of Colorado
#
#  Weevil is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  Weevil is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301
#  USA, or send email to serl@cs.colorado.edu.
#
# $Id: weevil2communicate.m4,v 1.4 2005/05/16 19:20:55 ywang Exp $
#
#!/bin/sh
#
# check the arguments
#
if [ $# -ne 2 ]
then
        echo "parameter error: You have $# arugment(s) instead of 2."
        echo "usage: sh WVL_Experiment_Name`_communicate.sh' <local path> <file name listing targets>"
        exit
elif [ ! -f $1/$2 ]
then
        echo "parameter error: The file you refer in the 2th argument does not exist."
        echo "usage: sh WVL_Experiment_Name`_communicate.sh' <local path> <file name listing targets>"
        exit
fi
tablefile=$1`/'WVL_Experiment_Name`_infotable'
changequote([[, ]])dnl
#
# decide the line number of the target file
#
linenum=`cat $1/$2 | wc -l`
enterornot=`tail -n 1 $1/$2 | wc -l`
if [ $enterornot -eq 0 ]
then
    linenum=`expr $linenum + 1`
fi
#
# get the information of the target and configure the parallel communication files
#
rm -rf $1/sendfiletasks
rm -rf $1/sendmessagetasks

for (( i=$linenum; i>0; i-- )){
    targetID=`tail -n $i $1/$2 | head -n 1`
    targetinfo=`grep \"$targetID\" $tablefile`
    targetAccount=`echo $targetinfo|awk -F[\ ] '{print $1}'`
    targetAddress=`echo $targetinfo|awk -F[\ ] '{print $2}'`
    targetPath=`echo $targetinfo|awk -F[\ ] '{print $3}'`
    targetReceiver=`echo $targetinfo|awk -F[\ ] '{print $4}'`
    echo "$targetID, $targetAccount@$targetAddress:$targetPath/" >> $1/sendfiletasks
    echo "$targetID, $targetAccount@$targetAddress|sh $targetPath/$targetReceiver" >> $1/sendmessagetasks
}
changequote(`, ')dnl
